package org.processmining.plugins.automapgen;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

import org.freehep.graphics2d.VectorGraphics;

/**
 * preview of a Cartesian image
 * 
 * @author ngupta
 *
 */
public class CartesianPlotImage extends JPanel {

	private static final long serialVersionUID = 1L;
	final float ratio = 1.0f;
	private BufferedImage image= null;

	public CartesianPlotImage(int height, int widht) {
		this.setPreferredSize(new Dimension((int) (ratio * widht) + 5, (int) (ratio * height) + 5));
	}

	public void setImage(BufferedImage image){
		this.image = image;
		this.repaint();
	}
	
	@Override
	public synchronized void paintComponent(Graphics g) {
		super.paintComponent(g);
		VectorGraphics g2d = VectorGraphics.create(g);
		if (image != null) {
			g2d.drawImage(image, 0, 0, null);
		}
	}

}