/**
 * 
 */
package org.processmining.plugins.automapgen;

import java.awt.Color;
import java.awt.Component;
import java.util.ArrayList;
import java.util.Collection;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.framework.util.ui.widgets.WidgetColors;

import com.fluxicon.slickerbox.factory.SlickerFactory;
import com.fluxicon.slickerbox.ui.SlickerScrollBarUI;

/**
 * @author ngupta
 *
 */
public class PanelObjects {
	
	protected JPanel createAxisPanel(ProMTextField min, ProMTextField max) {
		JPanel panel = new JPanel();
		panel = createPanel(min, max);
		return panel;
	}

	protected JButton createButton(String string) {
		JButton button;
		SlickerFactory slickerFactory = SlickerFactory.instance();
		button = slickerFactory.createButton(string);
		button.setAlignmentX(Component.CENTER_ALIGNMENT);
		return button;
	}

	protected JLabel createLabel(String string) {
		JLabel label = new JLabel(string);
		label.setForeground(WidgetColors.PROPERTIES_BACKGROUND);
		return label;
	}

	protected ProMTextField createTextFeild(String string) {
		ProMTextField txtFeild = new ProMTextField(string);
		return txtFeild;
	}
	
	protected JPanel createPanel(ProMTextField min, ProMTextField max) {
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.setOpaque(false);
		panel.add(min);
		panel.add(createLabel(" - "));
		panel.add(max);
		return panel;
	}

	@SuppressWarnings("rawtypes")
	protected JPanel createComboPanel(ProMComboBox first, ProMComboBox last) {
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.setOpaque(false);
		panel.add(first);
		panel.add(createLabel(" - "));
		panel.add(last);
		return panel;
	}
	
	@SuppressWarnings({ "unchecked", "rawtypes" })
	protected ProMComboBox createCombo(Collection<String> values) {
		ProMComboBox combo = new ProMComboBox(values);
		return combo;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	protected ProMComboBox createComboImage(ArrayList<Integer> list) {
		ProMComboBox combo = new ProMComboBox(list);
		combo.setEditable(true);
		return combo;
	}

	protected JScrollPane createScrollPanel(CartesianPlotImage previewImagePanel){
		JScrollPane scrollPane = new JScrollPane(previewImagePanel);
		scrollPane.getHorizontalScrollBar().setUI(new SlickerScrollBarUI(scrollPane.getHorizontalScrollBar()));
		scrollPane.getVerticalScrollBar().setUI(new SlickerScrollBarUI(scrollPane.getVerticalScrollBar()));
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setBorder(BorderFactory.createEmptyBorder());
		scrollPane.setBackground(Color.BLACK);
		return scrollPane;
	
	}
}
