/**
 * 
 */
package org.processmining.plugins.automapgen.merge;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.mapvis.importdata.visualization.MapVisData;

/**
 * @author ngupta
 * This plug-in will merge two visualisation map data files and creates one Map Vis file
 */

@Plugin(name = "Merge Automatic Map Generator Files", 
		returnLabels = { "Map File" }, 
		returnTypes = { MapVisData.class }, 
		parameterLabels = {"Map File 1","Map File 2","Map File 3","Map File 4","Map File 5"}, 
		userAccessible = true)

 public class MergeMapFile {
	@PluginVariant(requiredParameterLabels = {0})
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, 	
					author = "N.gupta", 
					email = "n.gupta@tue.nl")
	
	public static MapVisData mergeMapFilenPlugin(UIPluginContext context, MapVisData... maps ) {
		MapVisData mapVisData = new MapVisData();
	//	mapVisData.merge(map1, "_1_");
		for (int i = 0; i < maps.length; i++) {
			String postfix = "_" + i+ "_";
			mapVisData.merge(maps[i], postfix);
		}
		context.log("Successfully merged visualization maps!!");
		return mapVisData;		
	}
}