/**
 * 
 */
package org.processmining.plugins.automapgen.petrinet;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.framework.util.LevenshteinDistance;
import org.processmining.framework.util.ui.widgets.ProMComboBox;

/**
 * @author ngupta
 *
 */

@SuppressWarnings("hiding")
public class PetriGraphMapping<String, T> {
	//private static final long serialVersionUID = 1L;
	@SuppressWarnings("rawtypes")
	Map<String, ProMComboBox> comboBoxes = new HashMap<String, ProMComboBox>();
	JLabel mainInfo = new JLabel();
	JPanel componentPanel = new JPanel();

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public PetriGraphMapping(String name, Collection<T> coll1, boolean isNoMapping) {
		mainInfo.setText("Please provide the mapping for the following:");

		Set<Object> internalSet = new HashSet<Object>();
		internalSet.add("NO MAPPING");
		internalSet.addAll(coll1);

		Object retValue;

		retValue = getBestMatch(name, internalSet, isNoMapping);

		ProMComboBox component = new ProMComboBox(internalSet);
		component.setMaximumSize(new Dimension(300, 30));
		component.setPreferredSize(new Dimension(300, 30));

		if (name != null) {
			component.setSelectedItem(retValue);
			if (!retValue.toString().equals(name)) {
				component.setBackground(Color.YELLOW);
				component.setForeground(Color.GRAY);
			}
		}
		comboBoxes.put(name, component);
		componentPanel.setLayout(new GridLayout());
		JLabel label = new JLabel();

		component.setMaximumSize(new Dimension(100, 30));
		component.setPreferredSize(new Dimension(100, 30));
		label.setText((java.lang.String) name);
		label.setForeground(Color.white);

		componentPanel.add(label);
		componentPanel.add(component);
		componentPanel.setBackground(Color.GRAY);
	}

	private Object getBestMatch(String value, Set<Object> internalSet, boolean isNoMapping) {
		LevenshteinDistance ld = new LevenshteinDistance();
		int minDist = Integer.MAX_VALUE;
		Object minObject = null;

		for (Object internal : internalSet) {
			int ldist;
			if (internal.toString().length() == 0)
				ldist = value.toString().length();
			else
				ldist = ld.getLevenshteinDistanceLinearSpace(value.toString(), internal.toString().toUpperCase());
			if (ldist < minDist) {
				minDist = ldist;
				minObject = internal;
			}
		}

		if (isNoMapping && !minObject.toString().equals(value.toString())) {
			minObject = "NO MAPPING";

		}
		return  minObject;
	}

	@SuppressWarnings({ "unchecked" })
	public Map<String, T> getMapping(boolean includeNotMapped) {
		Map<String, T> retValue = new HashMap<String, T>();
		for (String node : comboBoxes.keySet()) {
			Object selection = comboBoxes.get(node).getSelectedItem();
			if (selection.toString().equals("NO MAPPING")) {
				if (includeNotMapped)
					retValue.put(node, null);
			} else
				retValue.put(node, (T) selection);
		}

		return retValue;
	}

	@SuppressWarnings("rawtypes")
	public void addComboValues(Map<String, ProMComboBox> combo) {
		comboBoxes.putAll(combo);
	}

}