package org.processmining.plugins.mapvis;

import java.io.Serializable;

import org.processmining.plugins.mapvis.importdata.visualization.MapVisData;
import org.processmining.plugins.mapvis.replay.History;
import org.processmining.plugins.mapvis.replay.TimeStampArray;

public class VisData implements Serializable {
	
	private static final long serialVersionUID = 1L;
	private org.processmining.plugins.mapvis.importdata.visualization.MapVisData mapVisData;
	private org.processmining.plugins.mapvis.replay.History history;
	private org.processmining.plugins.mapvis.replay.TimeStampArray ts;

	public VisData(History history, MapVisData mapVisData, String[] attributes,TimeStampArray ts) {
		this.history = history;
		this.mapVisData = mapVisData;
		this.ts=ts;
	}

	public void setMapVisData(org.processmining.plugins.mapvis.importdata.visualization.MapVisData mapVisData) {
		this.mapVisData = mapVisData;
	}
	public org.processmining.plugins.mapvis.importdata.visualization.MapVisData getMapVisData() {
		return mapVisData;
	}
	public void setHistory(org.processmining.plugins.mapvis.replay.History history) {
		this.history = history;
	}
	public org.processmining.plugins.mapvis.replay.History getHistory() {
		return history;
	}
	
	// for the Animation classes
	public long getStart() {
		return ts.getStart();
	}
	public long getEnd() {
		return ts.getEnd();
	}
	
	public void closeDb(){
		history.closeDB();
	}
}
