package org.processmining.plugins.mapvis.exportdata;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.mapvis.importdata.visualization.MapVisData;

@Plugin(name = "Export map visualization policy", parameterLabels = { "MapVisData", "File" }, returnLabels = {}, returnTypes = {}, userAccessible = true)
@UIExportPlugin(description = "XMVS files", extension = "xmvs")
public class MapVisDataExporter {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "A. Erdodi, M. de Leoni", email = "atilla.erdodi@gmail.com; m.d.leoni@tue.nl")
    @PluginVariant(requiredParameterLabels = { 0, 1 }, variantLabel = "Export map visualization policy")
    public void export(UIPluginContext context, MapVisData mapVisData, File file) throws IOException {
		FileOutputStream out = new FileOutputStream(file);
		PrintWriter p = new PrintWriter(out);
		p.write(mapVisData.toString());
		p.close();
        out.close();
	}
}
