package org.processmining.plugins.mapvis.importdata.visualization;

import java.io.Serializable;

public class AttributeKey  implements Serializable, Comparable<AttributeKey>{

	private static final long serialVersionUID = 1L;
	private String xAxis;
	private String yAxis;
		
	public AttributeKey( String xAxis,String yAxis ){
		this.xAxis = xAxis;
		this.yAxis = yAxis;
	}
	
	public String getxAxis() {
		return xAxis;
	}
	
	public String getyAxis() {
		return yAxis;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof AttributeKey))
			return false;
		if (obj == this)
			return true;
		AttributeKey rhs = (AttributeKey) obj;
		return xAxis.equals(rhs.xAxis) &&  yAxis.equals(rhs.yAxis);
	}

	@Override
	public int hashCode() {
		return (xAxis.hashCode()+yAxis.hashCode())*32;
	}

	public int compareTo(AttributeKey o) {
		int compare = xAxis.compareTo(o.xAxis);
		if (compare != 0)
			return compare;
		else
			return yAxis.compareTo(o.yAxis);
	}

}
