package org.processmining.plugins.mapvis.importdata.visualization;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.util.zip.GZIPInputStream;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.mapvis.VisData;
import org.processmining.plugins.mapvis.replay.NameLookUp;
import org.processmining.plugins.mapvis.replay.ProcessIDData;
import org.processmining.plugins.mapvis.replay.TimeStampArray;
import org.processmining.plugins.mapvis.visualize.workitem.AbstractWorkDotColorSchema;

@Plugin(name = "Open replayed visualization", parameterLabels = { "Filename" }, returnLabels = { "VisData" }, returnTypes = { VisData.class })
@UIImportPlugin(description = "Replayed visualization", extensions = { "xmlrplgz" })

public class ImportVisData extends AbstractImportPlugin {
	protected VisData importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		
		ObjectInputStream ois = new ObjectInputStream(new GZIPInputStream(new BufferedInputStream(input)));
		VisData visData = (VisData) ois.readObject();
		
		NameLookUp nameLookup = (NameLookUp) ois.readObject();
		NameLookUp.setLookUpTable(nameLookup);
		
		ProcessIDData processData = (ProcessIDData) ois.readObject();
		ProcessIDData.setProcessIDData(processData);
		
		AbstractWorkDotColorSchema colorSchema = (AbstractWorkDotColorSchema) ois.readObject();
		AbstractWorkDotColorSchema.setColorSchema(colorSchema);
		
		TimeStampArray timeStampArray = (TimeStampArray) ois.readObject();
		TimeStampArray.setTimeStampArray(timeStampArray);
		
		return visData;
	}
}
