package org.processmining.plugins.mapvis.replay;

public class ActivityKey implements Comparable<ActivityKey>, java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private short activityValue;
	private int caseIdValue;

	public ActivityKey(String name, String caseId) {
		this.activityValue = NameLookUp.getInstance().getValueByActivityName(name);
		this.caseIdValue = NameLookUp.getInstance().getValueByCaseId(caseId);
	}

	public String getActivityName() {
		return NameLookUp.getInstance().getActivityNamebyValue(activityValue);
	}

	public int getValueForCaseId() {
		return caseIdValue;
	}
	
	public String getCaseId() {
		return NameLookUp.getInstance().getCaseIdbyValue(caseIdValue);
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof ActivityKey))
			return false;
		if (obj == this)
			return true;

	    ActivityKey rhs = (ActivityKey) obj;
		return activityValue == rhs.activityValue && caseIdValue == rhs.caseIdValue;
	}

	@Override
	public int hashCode() {
		return activityValue + caseIdValue * 32;
	}

	public int compareTo(ActivityKey key) {
		int compare = Float.compare(caseIdValue, key.caseIdValue);
		if (compare != 0)
			return compare;
		else
			return Float.compare(activityValue, key.activityValue);
	}

	public String toString() {
		return getCaseId() + ": " + getActivityName();
	}
}
