package org.processmining.plugins.mapvis.replay;

import java.util.StringTokenizer;

public class Encode {
	public static String encodeText(String pText) {
		StringTokenizer tokenizer =
			new StringTokenizer(pText, "&<>\"", true);
		int tokenCount = tokenizer.countTokens();

		/* no encoding's needed */
		if (tokenCount == 1)
			return pText;

		/* text.length + (tokenCount * 6) gives buffer large
		 * enough so no addition memory would be needed and no
		 * costly copy operations would occur */
		StringBuilder buffer =
			new StringBuilder(pText.length() + tokenCount * 6);
		while (tokenizer.hasMoreTokens()) {
			String token = tokenizer.nextToken();
			if (token.length() == 1) {
				switch (token.charAt(0)) {
					case '&':
						buffer.append("&amp;");
						break;
					case '<':
						buffer.append("&lt;");
						break;
					case '>':
						buffer.append("&gt;");
						break;
					case '"':
						buffer.append("&quot;");
						break;
					default:
						buffer.append(token);
				}
			} else {
				buffer.append(token);
			}
		}
		return buffer.toString();
	}
}
