package org.processmining.plugins.mapvis.replay;

import java.util.Date;

public class Event extends AbsEvent implements Timestamped {

	private Date timestamp;

	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}

	public Date getTimestamp() {
		return timestamp;
	}

	public int compareTo(Timestamped o) {
		Date timestamp2 = o.getTimestamp();
		if (timestamp.after(timestamp2)) {
			return 1;
		} else if (timestamp.equals(timestamp2)) {
			if (o instanceof AbsEvent) {
				ActivityState thisActState = getState();
				ActivityState otherActState = ((AbsEvent) o).getState();
				return Byte.compare(thisActState.getProgressState(), otherActState.getProgressState());
			} else
				return 0;
		} else {
			return -1;
		}
	}

	@Override
	public boolean equals(Object o) {
		return timestamp.equals(((Timestamped) o).getTimestamp());
	}

	public boolean refer(String caseId) {
		return this.getCaseId().equals(caseId);
	}
}
