package org.processmining.plugins.mapvis.replay;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NameLookUp implements Serializable {

	private static final long serialVersionUID = 1L;
	private Map<String, Integer> caseIdLookUpTable1 = new HashMap <String, Integer>();
	private List<String> caseIdLookUpTable2 = new ArrayList<String>();
	private Map<String, Short> activityNameLookUpTable1 = new HashMap <String, Short>();
	private List<String> activityNameLookUpTable2 = new ArrayList<String>();
	private static NameLookUp Instance = null;

	private NameLookUp() {		
	}

	public static NameLookUp getInstance() {
		if (Instance == null)
			Instance = new NameLookUp();
		return Instance;
	}

	public static void setLookUpTable(NameLookUp newInstance) {
		Instance = newInstance;
	}

	public String getCaseIdbyValue(int value) {
		//synchronized (caseIdLookUpTable2) {
		if (value >= caseIdLookUpTable2.size())
			return null;
		else
			return caseIdLookUpTable2.get(value);
	//	}
	}

	public int getValueByCaseId(String caseId) {
	//		synchronized (caseIdLookUpTable1) {
		if (caseIdLookUpTable1.get(caseId) == null) {
	//			synchronized (caseIdLookUpTable2) {
			int retValue = caseIdLookUpTable2.size();
			caseIdLookUpTable1.put(caseId, retValue);
			caseIdLookUpTable2.add(caseId);
			return retValue;
		//	}
		} else
			return caseIdLookUpTable1.get(caseId).intValue();
	//	}
	}

	public String getActivityNamebyValue(short value) {
	//	synchronized (activityNameLookUpTable2) {
		if (value >= activityNameLookUpTable2.size())
			return null;
		else
			return activityNameLookUpTable2.get(value);
	//	}
	}

	public short getValueByActivityName(String activityName) {
	//	synchronized (activityNameLookUpTable1) {
		if (activityNameLookUpTable1.get(activityName) == null) {
	//			synchronized (activityNameLookUpTable2) {
			short retValue = (short) activityNameLookUpTable2.size();
			activityNameLookUpTable1.put(activityName, retValue);
			activityNameLookUpTable2.add(activityName);
			return retValue;
	//			}
		} else
			return activityNameLookUpTable1.get(activityName).shortValue();
	//	}
	}
}
