package org.processmining.plugins.mapvis.replay;

import java.io.StringReader;
import java.io.StringWriter;
import java.util.Properties;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import net.sf.saxon.Configuration;
import net.sf.saxon.query.DynamicQueryContext;
import net.sf.saxon.query.StaticQueryContext;
import net.sf.saxon.query.XQueryExpression;
import net.sf.saxon.trans.XPathException;



public class XQueryProcessor {
	private Configuration config = new Configuration();
	private StaticQueryContext staticContext;
	Properties props = new Properties();
	private static XQueryProcessor instance=new XQueryProcessor();

	public static XQueryProcessor getInstance()
	{
		return instance;
	}

	@SuppressWarnings("deprecation")
	private XQueryProcessor()
	{
		staticContext = new StaticQueryContext(config);
		props.setProperty(OutputKeys.METHOD, "xml");
		props.setProperty(OutputKeys.INDENT, "no");
	}

	public String performXQuery(String xml, XQueryExpression exp)
	{
		DynamicQueryContext dynamicContext = new DynamicQueryContext(config);
		StringReader sr=new StringReader(xml);
		try {
			dynamicContext.setContextItem(config.buildDocument(new StreamSource(sr)));
		} catch (Exception e) {
			e.printStackTrace();
		}
		StringWriter sw = new StringWriter();
		try{
			exp.run(dynamicContext, new StreamResult(sw), props);
			sw.flush();
			return (sw.toString());
		}
		catch(XPathException ex){
			System.err.println("Expression: " + exp.getExpression());
			System.err.println("Data: " + xml);
			ex.printStackTrace();
			return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		}
	}

	public StaticQueryContext getStaticContext() {
		return staticContext;
	}

}
