package org.processmining.plugins.mapvis.visualize;

import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.framework.util.ui.scalableview.ScalableComponent;
import org.processmining.framework.util.ui.scalableview.ScalableViewPanel;
import org.processmining.framework.util.ui.scalableview.interaction.ViewInteractionPanel;
import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.plugins.mapvis.replay.ProcessIDData;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * show relative and indexation between workItemDot
 * 
 * @author ngupta
 * 
 */
public class ComparativeAnalysis extends JPanel implements ViewInteractionPanel {

	private static final long serialVersionUID = 1L;
	private JButton jbnAnalysis;
	private MapImagePanel mapPanel;
	protected JLabel time = new JLabel();
	public JCheckBox indexationRBtn = SlickerFactory.instance().createCheckBox("Comparative analysis", false);
	public JCheckBox showRelativeCBox = SlickerFactory.instance().createCheckBox("Show relativity between dots", false);

	@SuppressWarnings("rawtypes")
	private JComboBox relativeAttribute = null;

	private final ComparativeAnalysisListner listener;

	public ComparativeAnalysis(MapImagePanel mapPanel, String[] attributes) {
		this.mapPanel = mapPanel;
		listener = new ComparativeAnalysisListner(this);
		initComponent(attributes);
	}

	//Create initial components for the export panel
	@SuppressWarnings("rawtypes")
	private void initComponent(String[] attributes) {
		this.setLayout(new GridLayout(5, 1));
		this.add(indexationRBtn);
		indexationRBtn.addActionListener(listener);
		indexationRBtn.setActionCommand(ComparativeAnalysisListner.INDEX);

		JPanel indexPanel = new JPanel();
		indexPanel.setLayout(new BoxLayout(indexPanel, BoxLayout.Y_AXIS));
		jbnAnalysis = SlickerFactory.instance().createButton("Choose current frame");
		jbnAnalysis.addActionListener(listener);
		jbnAnalysis.setActionCommand(ComparativeAnalysisListner.INDEXBUTTON);

		indexPanel.add(jbnAnalysis);
		this.add(indexPanel);

		JPanel timePanel = new JPanel();
		timePanel.add(new JLabel("Freeze time is :"));
		timePanel.add(time);
		this.add(timePanel);

		String[] relAttribute = new String[attributes.length];
		int i = 0;
		for (String attributeName : attributes) {
			boolean result = ProcessIDData.getInstance().getProcessAttributeNameType(attributeName);
			if (result) {
				relAttribute[i] = attributeName;
				i++; 
			}
		}
		JPanel relativePanel = new JPanel();
		if (relAttribute[0] != null) {
			this.add(showRelativeCBox);
			showRelativeCBox.addActionListener(listener);
			showRelativeCBox.setActionCommand(ComparativeAnalysisListner.RELATIVE);
			relativeAttribute = new ProMComboBox(relAttribute);
			relativePanel.add(new JLabel("Select relative attribute to consider :      "));
			relativePanel.add(relativeAttribute);
			relativeAttribute.addActionListener(listener);
			relativeAttribute.setActionCommand(ComparativeAnalysisListner.RELATIVECOMBO);
			relativeAttribute.setMaximumSize(new Dimension(300, 30));
			relativeAttribute.setPreferredSize(new Dimension(300, 30));
			this.add(relativePanel);
		}else{
			relativePanel.add(new JLabel(" The framework cannot apply relativity between dots because "
										 + "an event log does not have a numeric attribute"));		
		}
		this.add(relativePanel);
	}

	public String getPanelName() {
		return "Comparative";
	}

	public JComponent getComponent() {
		return this;
	}

	public MapImagePanel getImagePanel() {
		return mapPanel;
	}

	public String getSelectedRelativeAttribute() {
		return (String) relativeAttribute.getSelectedItem();
	}

	public double getHeightInView() {
		return this.getPreferredSize().getHeight();
	}

	public double getWidthInView() {
		return this.getPreferredSize().getWidth();
	}

	public void setScalableComponent(ScalableComponent scalable) {
	}

	public void setParent(ScalableViewPanel viewPanel) {
	}

	public void willChangeVisibility(boolean to) {
	}

	public void updated() {
	}

}
