package org.processmining.plugins.mapvis.visualize;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.processmining.plugins.mapvis.importdata.visualization.MapVisMap;
import org.processmining.plugins.mapvis.replay.TimeStampArray;
import org.processmining.plugins.mapvis.visualize.workitem.AbstractWorkDotColorSchema;

public class ComparativeAnalysisListner implements ActionListener, ItemListener {

	public static final String INDEX = "I";
	public static final String INDEXBUTTON = "IB";
	public static final String RELATIVECOMBO = "RC";
	public static final String RELATIVE = "R";

	private ComparativeAnalysis analysis;

	public ComparativeAnalysisListner(ComparativeAnalysis panel) {
		this.analysis = panel;
	}

	public void actionPerformed(ActionEvent arg0) {
		MapVisMap map = analysis.getImagePanel().getMapVisMap();
		String actionCommand = arg0.getActionCommand();
		boolean indexRelative = analysis.showRelativeCBox.isSelected();
		boolean index = analysis.indexationRBtn.isSelected();
		Long freezeFrameTime = null;
		if (actionCommand == INDEX) {
			analysis.getImagePanel().getParentPane().setIndextation(index);
			if (!index) {
				analysis.time.setText("");
				String text = analysis.getImagePanel().getParentPane().paraPanel.getRadioButtonSelect();

				if (text.contains("Age")) {
					analysis.getImagePanel().getParentPane().paraPanel.ageColoring2RBtn.setSelected(true);
					AbstractWorkDotColorSchema.schemaMap.put(map,
							AbstractWorkDotColorSchema.ColoringSchema.AGEDONACTIVITYMEANTIME);
				}
				if (text.contains("Attribute")) {
					analysis.getImagePanel().getParentPane().paraPanel.propertyColoringRBtn.setSelected(true);
					AbstractWorkDotColorSchema.schemaMap.put(map,
							AbstractWorkDotColorSchema.ColoringSchema.PROPERTYBASED);
				}
				if (text.contains("State")) {
					analysis.getImagePanel().getParentPane().paraPanel.stateColoringRBtn.setSelected(true);
					AbstractWorkDotColorSchema.schemaMap.put(map, AbstractWorkDotColorSchema.ColoringSchema.STATEBASED);
				}

				analysis.getImagePanel().getParentPane().recomputeLegend();
				freezeFrameTime = null;
			}
		} else if (actionCommand == INDEXBUTTON) {
			analysis.indexationRBtn.setSelected(true);
			freezeFrameTime = TimeStampArray.getInstance().getModelingTime();
			Date date = new Date(freezeFrameTime);
			SimpleDateFormat df2 = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss");
			String dateText = df2.format(date);
			analysis.time.setText(dateText.toString());
			freezeDot(freezeFrameTime, map);
		} else if (actionCommand == RELATIVECOMBO && indexRelative) {
			analysis.getImagePanel().getRelativeAttribute(analysis.getSelectedRelativeAttribute());
		} else if (actionCommand == RELATIVE) {
			analysis.getImagePanel().getParentPane().setRelativeToAttributeOn(analysis.showRelativeCBox.isSelected());
			analysis.getImagePanel().getRelativeAttribute(analysis.getSelectedRelativeAttribute());
			analysis.indexationRBtn.setSelected(false);
			analysis.getImagePanel().getParentPane().setIndextation(false);
			analysis.time.setText("");
		}

		if (freezeFrameTime == null) {
			analysis.getImagePanel().getParentPane().setFreezeIndextation(false);
		}

		analysis.getImagePanel().getParentPane().recalc();
	}

	private void freezeDot(long freezeFrameTime, MapVisMap map) {
		analysis.getImagePanel().getParentPane().getFreezeDot();
		analysis.getImagePanel().getParentPane().getFreezeInvalidCount();
		analysis.getImagePanel().getParentPane().getFreezeHiddenCount();
		analysis.getImagePanel().setFreezeTimeFrame(freezeFrameTime);
		analysis.getImagePanel().getParentPane().setFreezeIndextation(true);
		analysis.getImagePanel().getParentPane().setIndextation(analysis.indexationRBtn.isSelected());
		AbstractWorkDotColorSchema.schemaMap.put(map, AbstractWorkDotColorSchema.ColoringSchema.INDEX);
		analysis.getImagePanel().getParentPane().recomputeLegend();
	}

	public void itemStateChanged(ItemEvent arg0) {

	}

}
