package org.processmining.plugins.mapvis.visualize;


public class Coordinate implements Comparable<Coordinate> {

	private short x, y;

	public Coordinate(short x, short y) {
		this.x = x;
		this.y = y;
	}

	public short getX() {
		return this.x;
	}

	public short getY() {
		return this.y;
	}

	@Override
	public boolean equals(Object obj) {
		if (!(obj instanceof Coordinate))
			return false;
		if (obj == this)
			return true;

		Coordinate rhs = (Coordinate) obj;
		return x == rhs.x && y == rhs.y;
	}

	@Override
	public int hashCode() {
		return x + y * 32;
	}

	public int compareTo(Coordinate o) {
		int compare = Float.compare(x, o.x);
		if (compare != 0)
			return compare;
		else
			return Float.compare(y, o.y);
	}
	
	public String toString() {
		return getX() + ": " + getY();
	}
}
