package org.processmining.plugins.mapvis.visualize;

import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JOptionPane;

import org.processmining.plugins.mapvis.importdata.visualization.MapVisMap;
import org.processmining.plugins.mapvis.visualize.workitem.AbstractWorkDotColorSchema;

public class FilterListner implements java.awt.event.ActionListener, ItemListener {

	public static final String EVENT = "E";
	public static final String ATTRIBUTE = "A";
	public static final String ATTRIBUTEVALUE = "AV";
	public static final String ADDATTRIBUTE = "AD";
	public static final String EVENTITEM = "EI";
	private FilterPanel panel;

	public FilterListner(FilterPanel filterPanel) {
		this.panel = filterPanel;
	}

	public void actionPerformed(ActionEvent e) {
		MapVisMap map = panel.getImagePanel().getMapVisMap();
		String actionCommand = e.getActionCommand();
		Boolean showNumbers = AbstractWorkDotColorSchema.showNumberPerMap.get(map);
		if (showNumbers == null)
			showNumbers = true;

		if (actionCommand == ADDATTRIBUTE) {
			int input = JOptionPane.showOptionDialog(null, panel.attributeCombo, "Select attributes",
					JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE, null, null, null);
			if (input == JOptionPane.OK_OPTION) {
				panel.getCompoentsOnPanel();
			}
		}
		if (actionCommand == EVENT) {
			if (panel.eventSelection.isSelected()) {
				panel.getImagePanel().getParentPane().toggleEventFilterOn(true);
				panel.getImagePanel().getParentPane().setEventFilterValue(panel.getSelectedEvent());

			} else {
				panel.getImagePanel().getParentPane().toggleEventFilterOn(false);
			}
			panel.getImagePanel().getParentPane().recalc();
			panel.getImagePanel().getParentPane().recomputeValidChart(showNumbers);
			panel.getImagePanel().getParentPane().recomputeColorChart(showNumbers);
			panel.getImagePanel().getParentPane().addCharts();
		}

		if (actionCommand == ATTRIBUTE) {
			if (panel.attributeSelection.isSelected()) {
				panel.getImagePanel().getParentPane().toggleAttributeFilterOn(true);
				panel.getImagePanel().getParentPane().setAttributeFilterValue(panel.getSelectedAttribute());
				panel.getImagePanel().getParentPane().setAttributeValues(panel.mergeMappings());
			} else {
				panel.getImagePanel().getParentPane().toggleAttributeFilterOn(false);
			}
			panel.getImagePanel().getParentPane().recalc();
			panel.getImagePanel().getParentPane().recomputeValidChart(showNumbers);
			panel.getImagePanel().getParentPane().recomputeColorChart(showNumbers);
			panel.getImagePanel().getParentPane().addCharts();
		}
	}

	@SuppressWarnings("unchecked")
	public void itemStateChanged(ItemEvent arg0) {
		MapVisMap map = panel.getImagePanel().getMapVisMap();
		Boolean showNumbers = AbstractWorkDotColorSchema.showNumberPerMap.get(map);
		if (showNumbers == null)
			showNumbers = true;

		if (panel.eventSelection.isSelected()) {
			panel.getImagePanel().getParentPane().toggleEventFilterOn(true);
			panel.getImagePanel().getParentPane().setEventFilterValue(panel.eventAttributeCombo.getSelectedItems());
			panel.getImagePanel().getParentPane().recalc();
			panel.getImagePanel().getParentPane().recomputeValidChart(showNumbers);
			panel.getImagePanel().getParentPane().recomputeColorChart(showNumbers);
			panel.getImagePanel().getParentPane().addCharts();
		}

		if (panel.attributeSelection.isSelected()) {
			panel.getImagePanel().getParentPane().toggleAttributeFilterOn(true);
			panel.getImagePanel().getParentPane().setAttributeFilterValue(panel.attributeCombo.getSelectedItems());
			panel.getImagePanel().getParentPane().setAttributeValues(panel.mergeMappings());
			panel.getImagePanel().getParentPane().recalc();
			panel.getImagePanel().getParentPane().recomputeValidChart(showNumbers);
			panel.getImagePanel().getParentPane().recomputeColorChart(showNumbers);
			panel.getImagePanel().getParentPane().addCharts();
		}

	}
}
