package org.processmining.plugins.mapvis.visualize;

import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import org.jfree.chart.ChartMouseEvent;
import org.jfree.chart.ChartMouseListener;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.plot.XYPlot;

public class MyChartMouseListener implements ChartMouseListener {

	private AnimationTimer timer;
	private ChartPanel chartPanel;

	public MyChartMouseListener(ChartPanel chartPanel,AnimationTimer timer) {
		this.timer=timer;
		this.chartPanel=chartPanel;
	}

	public void chartMouseClicked(ChartMouseEvent event) {
		Point2D p = chartPanel.translateScreenToJava2D(event.getTrigger().getPoint());
		Rectangle2D plotArea = chartPanel.getScreenDataArea();
		XYPlot plot = (XYPlot) chartPanel.getChart().getPlot(); 
		long chartX = (long) plot.getDomainAxis().java2DToValue(p.getX(), plotArea, plot.getDomainAxisEdge());
		timer.setAbsolutePosition(chartX);			
	}

	public void chartMouseMoved(ChartMouseEvent arg0) {

	}

}
