package org.processmining.plugins.mapvis.visualize;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.framework.util.ui.widgets.WidgetColors;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class PanelComponents {
	
	protected JLabel createLabel(String string) {
		JLabel label = new JLabel(string);
		label.setForeground(WidgetColors.PROPERTIES_BACKGROUND);
		return label;
	}

	protected JButton createButton(String string) {
		JButton button;
		SlickerFactory slickerFactory = SlickerFactory.instance();
		button = slickerFactory.createButton(string);
		button.setAlignmentX(Component.RIGHT_ALIGNMENT);
		return button;
	}

	protected JPanel createPanel(JButton button) {
		JPanel panel = new JPanel();
		panel.setOpaque(false);
		panel.add(button);
		return panel;
	}

	protected JPanel createPanel(ProMTextField min, ProMTextField max) {
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.setOpaque(false);
		panel.add(min);
		panel.add(max);
		panel.setMaximumSize(new Dimension(300, 30));
		return panel;
	}

	
}
