package org.processmining.plugins.mapvis.visualize;

import java.awt.event.ActionEvent;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.processmining.plugins.mapvis.importdata.visualization.MapVisMap;
import org.processmining.plugins.mapvis.visualize.workitem.AbstractWorkDotColorSchema;

class ParameterPanelListener implements java.awt.event.ActionListener, ChangeListener {
	public static final String MERGEDOTCBOX = "M";
	public static final String STATERADIOBTN = "S";

	public static final String PROPERTYRADIOBTN = "P";
	public static final String AGEWRTSINGLERADIOBTN = "A2";
	public static final String FADINGCBOX = "F";
	public static final String DISCRIMINATINGCOMBO = "D";
	public static final String SHOWDOTSNUMBER = "SS";
	public static final String BLACKWHITE = "BW";
	private ParameterPanel panel;
	boolean showSelectedEvents;

	public ParameterPanelListener(ParameterPanel parameterPanel) {
		this.panel = parameterPanel;
	}

	public void actionPerformed(ActionEvent arg0) {
		MapVisMap map = panel.getImagePanel().getMapVisMap();
		AbstractWorkDotColorSchema.getInstance().setMapVisMap(map);
		String actionCommand = arg0.getActionCommand();
		if (actionCommand == MERGEDOTCBOX )
			mergeDot();
		else if (actionCommand == STATERADIOBTN ) {
			AbstractWorkDotColorSchema.schemaMap.put(map, AbstractWorkDotColorSchema.ColoringSchema.STATEBASED);
		} else if (actionCommand == AGEWRTSINGLERADIOBTN ) {
			AbstractWorkDotColorSchema.schemaMap.put(map,
					AbstractWorkDotColorSchema.ColoringSchema.AGEDONACTIVITYMEANTIME);
		} else if (actionCommand == PROPERTYRADIOBTN ) {
			AbstractWorkDotColorSchema.schemaMap.put(map, AbstractWorkDotColorSchema.ColoringSchema.PROPERTYBASED);
		} else if (actionCommand == SHOWDOTSNUMBER) {
			boolean showNumbers = panel.showDotsNumberCBox.isSelected();
			AbstractWorkDotColorSchema.showNumberPerMap.put(panel.getImagePanel().getMapVisMap(), showNumbers);
		} else if (actionCommand == FADINGCBOX ) {
			panel.getImagePanel().getParentPane().toggleFadingOn();
		} else if (actionCommand == BLACKWHITE) {
			panel.getImagePanel().getParentPane().toggleBlackNWhiteOn();
			panel.getImagePanel().recomputeMapColor();
		} else if (actionCommand == DISCRIMINATINGCOMBO ) {
			AbstractWorkDotColorSchema.discriminatingAttribute.put(map, panel.getSelectedDiscriminatingAttribute());
		} 
		Boolean showNumbers = AbstractWorkDotColorSchema.showNumberPerMap.get(map);
		if (showNumbers == null)
			showNumbers = true;

		panel.getImagePanel().getParentPane().recalc();
		
		panel.getImagePanel().getParentPane().recomputeColorChart(showNumbers);
		panel.getImagePanel().getParentPane().addColorChart();
		panel.getImagePanel().getParentPane().setAgeDataForLegend(panel.getImagePanel().getColordata());
		panel.getImagePanel().getParentPane().recomputeLegend();

	}

	private void mergeDot() {
		panel.getImagePanel().setMergeWithPartialOverlap(panel.mergeOverlappingCBox.isSelected());
	}

	public void stateChanged(ChangeEvent arg0) {
		panel.getImagePanel().getParentPane().setFadingTimeWindow(panel.getFadingSliderValue());
		panel.getImagePanel().getParentPane().recalc();
	}

}