package org.processmining.plugins.mapvis.visualize;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Visualize map",
		returnLabels = { "Visualization of map" },
		returnTypes = { JComponent.class },
		parameterLabels = { "Visualization data" },
		userAccessible = true)
@Visualizer
public class VisualizeMaps {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(final PluginContext context, final org.processmining.plugins.mapvis.VisData visData) {
		VisualizeMapsPanel panel = null;
		try {
			panel = new VisualizeMapsPanel(visData , context);
			//context.addConnection(new VisualizeMapsConnection(panel));
		} catch(ArrayIndexOutOfBoundsException e1)
		{
			e1.printStackTrace();
			JOptionPane.showMessageDialog(null, "Sorry! This event log cannot be used since it " +
					"does not specify the event life-cycle (e.g., start and complete)");
		}
		return panel;

	}

}
