package org.processmining.plugins.mapvis.visualize;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.mapvis.importdata.visualization.MapVisMap;

import com.fluxicon.slickerbox.components.SlickerTabbedPane;

public class VisualizeMapsPanel extends JPanel {
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("serial")
	public VisualizeMapsPanel(org.processmining.plugins.mapvis.VisData visData , PluginContext context) {
		double speedFactor = 10;
		timer = new AnimationTimer(visData.getStart(), visData.getEnd(), speedFactor, 20);
		this.setBackground(Color.BLACK);
		
		SlickerTabbedPane mapTabbedPane = new SlickerTabbedPane("Maps", new Color(240, 240, 240, 230),
																		new Color(0, 0, 0, 230),
																		new Color(220, 220, 220, 150)) {
			private MapPanel prev = null;
			public void activateTab(FlatTab selectedTab) {
				super.activateTab(selectedTab);
				MapPanel oneTab = (MapPanel)this.getSelected();
				if (prev != null) 
					prev.setActive(false);
	        	oneTab.setActive(true);
	        	oneTab.recalc();
	        	prev = oneTab;
			}
		};
		
		
		mapTabbedPane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		mapTabbedPane.setBackground(Color.BLACK);


		for (String mapName : visData.getMapVisData().getMapNames()) {
			MapVisMap map = visData.getMapVisData().getMap(mapName);
			MapPanel mapPanel = new MapPanel(map, timer,visData.getHistory(), context);
	
			mapTabbedPane.addTab(mapName, mapPanel);
			timer.addListener(mapPanel);
		}	
		
		
		JPanel controlPanel = new ControlPanel(visData, mapTabbedPane, timer);
		
		setBorder(BorderFactory.createEmptyBorder());
		setLayout(new BorderLayout());
		add(mapTabbedPane, BorderLayout.CENTER);
		add(controlPanel, BorderLayout.SOUTH);

		revalidate();
	}
	
	AnimationTimer timer;
}
