package org.processmining.plugins.mapvis.visualize.workitem;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import org.processmining.plugins.mapvis.importdata.visualization.MapVisMap;

/***
 * Define the colour schema's for Abstract workItemDot
 * 
 * @author ngupta
 *
 */
public class AbstractWorkDotColorSchema implements Serializable {
	
	private static final long serialVersionUID = 1L;

	public enum ColoringSchema {
		STATEBASED, PROPERTYBASED, AGEDONACTIVITYMEANTIME ,INDEX
	};

	public static Map<MapVisMap, ColoringSchema> schemaMap = new HashMap<MapVisMap, ColoringSchema>();
	public static Map<MapVisMap, String> discriminatingAttribute = new HashMap<MapVisMap, String>();	
	public static Map<MapVisMap, Boolean> indexation = new HashMap<MapVisMap, Boolean>();	
	public static Map<MapVisMap, Boolean> showNumberPerMap = new HashMap<MapVisMap, Boolean>();
	private MapVisMap map;
	private static AbstractWorkDotColorSchema Instance = null;;
	
	public  MapVisMap getMapVisMap() {
		return this.map;
	}
	
	public static AbstractWorkDotColorSchema getInstance() {
		if (Instance == null)
			Instance = new AbstractWorkDotColorSchema();
		return Instance;
	}

	public static void setColorSchema(AbstractWorkDotColorSchema newInstance) {
		Instance = newInstance;
	}
	
	public  void setMapVisMap(MapVisMap setMap) {
		this.map = setMap;
	}

}
